SystemOrganization addCategory: #'Cormas-Model-FireAutomata'!

CMAgentCommLocation subclass: #CMFireman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-Model-FireAutomata'!

!CMFireman commentStamp: 'NickPapoulias 9/16/2016 09:47' prior: 0!
TODO!

!CMFireman methodsFor: 'as yet unclassified' stamp: 'BrunoBonte 4/25/2018 13:13'!
extinctFire

		self patch state = #fire ifTrue: [self patch state: #empty. self patch bufferState: #empty. ]! !

!CMFireman methodsFor: 'as yet unclassified' stamp: 'BrunoBonte 4/25/2018 13:17'!
move

	| firedNeighbours |
	firedNeighbours := self nearestLocationsVerifying: [:cell | cell state = #fire] withinRadius: 4.
	firedNeighbours isEmpty
		ifTrue: [self randomWalk]
		ifFalse: [
			"self leave."
			self moveTo: (Cormas selectRandomlyFrom: firedNeighbours)
		]! !

!CMFireman methodsFor: 'as yet unclassified' stamp: 'BrunoBonte 4/25/2018 11:44'!
pov
	"^#empty ^#tree ^#fire ^#ash"

	^ Color blue! !

!CMFireman methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/19/2016 12:09'!
step

	self move.
	self extinctFire.! !

CMSpatialEntityCell subclass: #CMFireAutomataCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-Model-FireAutomata'!

!CMFireAutomataCell commentStamp: 'SergeStinckwich 4/3/2016 14:55' prior: 0!
I'm a cell of a FireAutomata. Four states are possible: #tree, #empty, #ash, #fire!

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NickPapoulias 9/15/2016 10:31'!
ash
	"^#empty ^#tree ^#fire ^#ash"

	^ Color gray! !

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NickPapoulias 9/15/2016 11:39'!
empty
	"^#empty ^#tree ^#fire ^#ash"

	^ Color black! !

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NickPapoulias 9/15/2016 10:31'!
fire
	"^#empty ^#tree ^#fire ^#ash"

	^ Color red ! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'SergeStinckwich 4/2/2015 20:39'!
init50
	Cormas random < 0.5
		ifTrue: [ self state: #tree ]
		ifFalse: [ self state: #empty ]! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'SergeStinckwich 4/2/2015 20:39'!
init53
	Cormas random < 0.53
		ifTrue: [ self state: #tree ]
		ifFalse: [ self state: #empty ]! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'SergeStinckwich 4/2/2015 20:39'!
init58
	Cormas random < 0.58
		ifTrue: [ self state: #tree ]
		ifFalse: [ self state: #empty ]! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'SergeStinckwich 3/5/2015 17:24'!
initEmpty
	self state: #empty! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'NickPapoulias 9/15/2016 11:23'!
initWith: aNumber

	Cormas random < aNumber
		ifTrue: [ self state: #tree ]
		ifFalse: [ self state: #empty ]! !

!CMFireAutomataCell methodsFor: 'control' stamp: 'BrunoBonte 4/25/2018 13:20'!
newState
	self state = #tree
		ifTrue: [( (self neighbourhood anySatisfy: [ :a | a state = #fire ]) and:[Cormas random < 0.5])
				ifTrue: [ self bufferState: #fire ]
				ifFalse: [ self bufferState: #tree ] ].
	self state = #fire
		ifTrue: [ Cormas random < 0.05
						ifTrue: [self bufferState: #ash]
						ifFalse: [self bufferState: #fire] ].
	self state = #ash
		ifTrue: [ Cormas random < 0.2
						ifTrue: [self bufferState: #empty ]
						ifFalse: [self bufferState: #ash]].
	self state = #empty
		ifTrue: [ self bufferState: #empty ]! !

!CMFireAutomataCell methodsFor: 'pov' stamp: 'BrunoBonte 4/25/2018 12:07'!
pov
	"^#empty ^#tree ^#fire ^#ash"
	(self occupantsAt: CMFireman) isEmpty not ifTrue:[^Color brown].

	^ self perform: self state! !

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NickPapoulias 9/15/2016 10:32'!
tree
	"^#empty ^#tree ^#fire ^#ash"

	^ Color green! !

CormasModel subclass: #CMFireAutomataModel
	instanceVariableNames: 'trees theCMFireAutomataCells numberOfFires percentageOfTrees theFiremans numberOfFiremen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-Model-FireAutomata'!

CMFireAutomataModel class
	instanceVariableNames: 'defaultInit'!

!CMFireAutomataModel commentStamp: 'SergeStinckwich 3/24/2016 16:01' prior: 0!
This model illustrates how the principles of cellular automata are implemented in Cormas. 

The spatial entity of the model (the cell), named FireAutomataCell, can take four states: #fire (red), #tree (green), #ash (grey), #empty (white). 

The initial state of each cell of the spatial grid is either set to #tree with a probability p or to #empty with a probability 1-p. 

One cell is set on fire, and then the spreading of the fire, defined in the cell transition function, occurs. The transition function is the following: a cell being a tree at time t-1 will become on fire at time t if at least one of its 4 neighbours (North, East, South, West) is on fire at time t-1. 

The cells being on fire will become ash at the next timestep, the cells being ash will become empty at the next timestep. 

The probability to observe a resteint fire is high if p is lower than 0.55, whereas when p is greater than 0.55, a global fire is likely to occur. 

This percolation threshold characterizes cellular automata which are representing diffusion processes.!

CMFireAutomataModel class
	instanceVariableNames: 'defaultInit'!

!CMFireAutomataModel class methodsFor: 'default settings' stamp: 'SergeStinckwich 3/29/2016 16:53'!
defaultControl
	^ #stepSynchronously:! !

!CMFireAutomataModel class methodsFor: 'default settings' stamp: 'NickPapoulias 9/16/2016 09:07'!
defaultInit

	^ defaultInit ifNil: [ defaultInit := #init58WithFire ]! !

!CMFireAutomataModel class methodsFor: 'default settings' stamp: 'NickPapoulias 9/15/2016 10:55'!
defaultInit: aSelector

	defaultInit := aSelector! !

!CMFireAutomataModel class methodsFor: 'default settings' stamp: 'SergeStinckwich 3/29/2016 16:53'!
defaultProbes
	^ #(#nbTrees)! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NickPapoulias 9/16/2016 09:38'!
example1
	| aModel nbLines v es anim |
	self defaultInit: #init58WithFire.
	aModel := self
		initialize;
		new.
	nbLines := 100.
	aModel initializeSpaceModel.
	aModel
		createGridX: nbLines
		Y: nbLines
		neighbourhood: 4
		closed: true.
	v := RTView new.
	aModel initSimulation.
	aModel runStep.
	es := (RTBox new
		color: [ :e | 
			e state == #tree
				ifTrue: [ Color green ]
				ifFalse: [ e state == #fire
						ifTrue: [ Color red ]
						ifFalse: [ e state == #ash
								ifTrue: [ Color gray ]
								ifFalse: [ Color black ] ] ] ];
		size: 25) elementsOn: aModel theCMFireAutomataCells.
	v addAll: es.
	RTGridLayout new
		gapSize: 0;
		lineItemsCount: aModel spaceModel column;
		on: v elements.
	v canvas camera focusOnCenterScaled.
	anim := RTActiveAnimation new.
	anim intervalInMilliseconds: 0.
	anim
		blockToExecute: [ aModel runStep.
			v elements do: #updateShape ].
	anim inView: v.
	v openWithToolbar! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NickPapoulias 4/26/2018 12:56'!
example2
	| aModel |
	
	aModel := self newWithProgrammableScenario 
		numberOfFires: 3;
		numberOfFiremen: 20;
		percentageOfTrees: 0.58;
		dimensions: 80->80;
		activeControl: #step:;
		initSimulation.

	
	(CMPharoGridSimulation new on: aModel with: aModel theCMFireAutomataCells) 
		runAndVisualize.
		
	! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'BrunoBonte 4/25/2018 13:16'!
example3
	| aModel |
	
	aModel := self newWithProgrammableScenario 
		numberOfFires: 3;
		numberOfFiremen: 20;
		percentageOfTrees: 0.60;
		dimensions: 80->80;
		activeControl: #step:;
		initSimulation.

	
	(CMPharoGridSimulation new on: aModel with: aModel theCMFireAutomataCells and: aModel theCMFiremans) 
		runAndVisualize.
		
	! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NickPapoulias 9/15/2016 11:35'!
newWithProgrammableScenario

	^ self 
		defaultInit: #initWithProgrammableScenario;
		initialize;
		new.! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/15/2016 11:38'!
dimensions: aPair

	self initializeSpaceModel.

	self
		createGridX: aPair key
		Y: aPair value
		neighbourhood: 4
		closed: true.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'SergeStinckwich 3/31/2016 14:07'!
howToRunIt

| txt |
txt := '1. Prepare the visualisation of the spatial grid\' withCRs asText emphasizeAllWith: #(#bold #large).

txt := txt, '1.1 Click on the first icon of the ' asText, ('Visualisation ' asText emphasizeAllWith: #color -> ColorValue red), 'area to open the standard spatial grid.\' withCRs asText.

txt := txt, '1.2 In the ' asText, ('Topology ' asText emphasizeAllWith: #italic), 'menu, clicking on the ' asText, ('Grid size ' asText emphasizeAllWith: #italic), 'item opens a window allowing you to choose the number of lines and columns. For example, choose 30 * 30.\' withCRs asText.

txt := txt, '1.3 Check the border condition: ' asText, ('Topology -> Grid boundaries -> closed' asText emphasizeAllWith: #italic), '.\' withCRs asText.

txt := txt, '1.4 Right-click within the spatial grid window to select the ' asText, ('pov ' asText emphasizeAllWith: #italic), 'view for ' asText, ('FireAutomata_Cell ' asText emphasizeAllWith: #italic), '.\' withCRs asText.

txt := txt, '1.5 To display the legend of this viewpoint: ' asText, ('Tools -> Display legends.\\' withCRs asText emphasizeAllWith: #italic).



txt := txt, ('2. Prepare the initial spatial grid\' withCRs asText emphasizeAllWith: #(#bold #large)).

txt := txt, '2.1 Click on the ' asText, ('Initialize ' asText emphasizeAllWith: #italic), 'button of the ' asText, ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\' withCRs asText.

txt := txt, '2.2 Select the ' asText, ('init53 ' asText emphasizeAllWith: #italic), 'and ' asText, ('stepSynchronously: ' asText emphasizeAllWith: #italic), 'methods, then validate by clicking on ' asText, ('Apply and close.\' asText emphasizeAllWith: #italic) withCRs asText.

txt := txt, '2.3 From the spatial grid menu, use ' asText, ('Tools -> Click to... -> Change attribute... -> state' asText emphasizeAllWith: #italic), ', enter ' asText, ('fire ' asText emphasizeAllWith: #italic), 'and validate. The cursor takes a new shape. Click on a cell to change manually its state to fire, then switch back to the mouse select mode with ' asText, ('Tools -> Click to... -> Select ' asText emphasizeAllWith: #italic), '.\\' withCRs asText. 



txt := txt, ('3. Run the model\' withCRs asText emphasizeAllWith: #(#bold #large)).

txt := txt, '3.1 Enter 50 in the ' asText, ('Final time ' asText emphasizeAllWith: #italic), 'input field of the ' asText,  ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\' withCRs asText.

txt := txt, '3.2 Click on the ' asText, ('Run ' asText emphasizeAllWith: #italic), 'button of the ' asText,  ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\\' withCRs asText.



txt := txt, ('4. Have a look at the charts\' withCRs asText emphasizeAllWith: #(#bold #large)).

txt := txt, '4.1 Click on the third icon of the ' asText, ('Visualisation ' asText emphasizeAllWith: #color -> ColorValue red), 'area to open the charts window.\\' withCRs asText.



txt := txt, ('5. Run alternative versions of the model\' withCRs asText emphasizeAllWith: #(#bold #large)).

txt := txt, '5.1 Select the ' asText, ('init58 ' asText emphasizeAllWith: #italic), 'and ' asText, ('stepSynchronously: ' asText emphasizeAllWith: #italic), 'methods, then run the model again.\' withCRs asText.

txt := txt, '5.2 Select the ' asText, ('init53 ' asText emphasizeAllWith: #italic), 'and ' asText, ('stepAsynchronously: ' asText emphasizeAllWith: #italic), 'methods, then run the model again.\' withCRs asText.

ComposedTextView open: txt asValue label: ('How to run ', self name, '     step-by-step instructions') icon: (Icon constantNamed: #workspace) extent: 620@550! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'nbecu 6/2/2015 13:19'!
init53
	self initCells: #init53! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'nbecu 6/2/2015 13:21'!
init53WithFire
	self initCells: #init53.
	self pickCell state: #fire.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'nbecu 6/2/2015 13:21'!
init58
	self initCells: #init58.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'nbecu 6/2/2015 13:21'!
init58WithFire
	self initCells: #init58.
	self pickCell state: #fire.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NickPapoulias 9/15/2016 11:21'!
init58WithMultipleFires

	self initCells: #init58.
	1 to: 10 do: [:i | self pickCell state: #fire].
	! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NickPapoulias 4/26/2018 16:00'!
initAgents
"To be completed"

	self setRandomlyLocatedAgents: CMFireman n: numberOfFiremen.
	self generateSymetricNetworkDensity: 1 forAgents: CMFireman.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NickPapoulias 9/16/2016 09:25'!
initSimulation

	super initSimulation.
	self runStep.

	! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NickPapoulias 9/16/2016 09:52'!
initWithProgrammableScenario

	self initCells: #initWith: withArguments: {percentageOfTrees}.
	1 to: numberOfFires do: [:i | self pickCell state: #fire].
	self initAgents.! !

!CMFireAutomataModel methodsFor: 'probes' stamp: 'SergeStinckwich 4/1/2016 20:38'!
nbTrees
	^ self theCMConwayCells count: [ :c | c state = #tree ]! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NickPapoulias 9/19/2016 12:22'!
numberOfFiremen: aNumber

	numberOfFiremen := aNumber! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/15/2016 11:25'!
numberOfFires

	^ numberOfFires! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/15/2016 11:25'!
numberOfFires: aNumber

	numberOfFires := aNumber! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NickPapoulias 9/15/2016 11:28'!
percentageOfTrees

	^ percentageOfTrees ! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NickPapoulias 9/15/2016 11:28'!
percentageOfTrees: aNumber

	percentageOfTrees := aNumber! !

!CMFireAutomataModel methodsFor: 'control' stamp: 'NickPapoulias 9/19/2016 12:10'!
step: t
"To be completed"

	self stepSynchronously: t.
	self theCMFiremans do: [:fm | fm step].! !

!CMFireAutomataModel methodsFor: 'control' stamp: 'nbecu 6/2/2015 13:21'!
stepAsynchronously: t
	super stepAsynchronously: t.! !

!CMFireAutomataModel methodsFor: 'control' stamp: 'nbecu 6/2/2015 13:21'!
stepSynchronously: t
	super stepSynchronously: t.! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 14:57'!
theCMFireAutomataCells
	"Returns a collection of all the instances of the sub classes collected by cormasModel.
	!!!! This method was automatically generated by Cormas !!!!"

	^ theCMFireAutomataCells ifNil: [ theCMFireAutomataCells := OrderedCollection new ]! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 14:57'!
theCMFireAutomataCells: aCollection
	theCMFireAutomataCells := aCollection! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/19/2016 10:28'!
theCMFiremans
	"Returns a collection of all the instances of the sub classes collected by cormasModel.
	This method was automatically generated by Cormas.
	!!!! BECAREFUL, You should not modify this method as it can be generated again when changing the value (Sensitivity Analysis for ex) !!!!"


^theFiremans ifNil:[theFiremans := IndexedSet new]! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/19/2016 10:28'!
theCMFiremans: aNewCollection
	"Set a new collection for theXXXs attribute.
	This method was automatically generated by Cormas.
	!!!! BECAREFUL, You should not modify this method as it can be generated again when changing the value (Sensitivity Analysis for ex) !!!!"

	theFiremans := aNewCollection! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/24/2015 13:16'!
trees
	trees isNil
		ifTrue: [ trees := OrderedCollection new ].
	^ trees! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'SergeStinckwich 3/24/2016 16:02'!
trees: aCollection
	trees := aCollection! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 14:56'!
treesData
	"return the data to be plotted with the trees chart"

	^ (self theCMFireAutomataCells count: [ :c | c state = #tree ]) / self theCMFireAutomataCells size! !
